/**
 * Memory Analyser  version 1.00
 * Copyright (c) 2018, Tycho Veltmeijer.
 * All rights reserved.
**/

#include "Filter_IE.h"

/*IE Filter contains 3 filters. two of which find URLS and the other one will search for Cookies, the filters are described in "4. Internet Explorer".
Filter 1: described in "4.1 URL's", ASCII form
Filter 2: described in "4.1 URL's", Unicode form
Filter 3: cookies, described in "4.2 Cookies" */

/*--------------------------------------------------------Filter 1--------------------------------------------------------*/
DUMP_SESSION* InitiateIEFilter1(char* location, char* argument, int analyse_type) {
		return CreateMemoryDump(location, "IE_URL_ASCII_Search.txt", 0, 
		(argument==(char*) -1 ? DS_WRITE_LOCATION_STRING : strtol(argument, NULL, 10))
	);
}

/*Search for all URLs visited Internet explorer (ASCII) .*/
int ApplyIEFilter1(DUMP_SESSION* dmp, HANDLE process, MEMORY_BASIC_INFORMATION* memInfo, char* buff, SIZE_T overflowSize) {
	/*'Signature':
	
		"Visited :" user@URL

	
	*/
	char signature[9]={0x56, 0x69, 0x73, 0x69, 0x74, 0x65, 0x64, 0x3A, 0x20};
	char* moveBuff=buff;  //Cur pos
	char* moveBuff2=buff; //Back-up cur pos
	int writtenBytes;	  //Returnvalue from Writefile()
	int readSize=0;		  //size of found URL

	if(memInfo->State!=MEM_FREE && memInfo->State!=MEM_RESERVE) {
		for(; moveBuff<(buff + memInfo->RegionSize); moveBuff++) {
				if(	memcmp(moveBuff, signature,  9) == 0) { //Look for "Visited :"

					/*look for @, that is where the username ends (deze eindigt met een apenstaartje)*/
					moveBuff2 = moveBuff+9;
					while(*moveBuff2!='@' && moveBuff2!=buff+overflowSize && *moveBuff2!=0)
						moveBuff2++;

					if(*moveBuff2=='@' && moveBuff2!=buff+overflowSize) {
						moveBuff2++;

						/*look if the protocolname meets it's requirments*/
						while(moveBuff2!=buff+overflowSize && *moveBuff2!=0
						&& !(*moveBuff2==':')
						&& !(
						(*moveBuff2 < 'a' || *moveBuff2 > 'z') 
						&& (*moveBuff2 < '0' || *moveBuff2 > '9') 
						&& *moveBuff2 != '-'
						&& *moveBuff2 != '.')
						)
							moveBuff2++;

						/*If protocolname is found it is a URL, write it to file*/
						if(moveBuff2!=buff+overflowSize && *moveBuff2!=0 &&
							(*moveBuff2==':')) {
							if(dmp->flags&DS_WRITE_LOCATION_STRING) {
								printf("Address: %p: ", (memlong) memInfo->BaseAddress + (moveBuff - buff));
								sprintf(dmp->string_location, "Address: %p: ", (memlong) memInfo->BaseAddress + (moveBuff - buff));
								WriteFile(dmp->dumpFile, dmp->string_location, strlen(dmp->string_location), (LPDWORD) &writtenBytes, NULL);
							}

							moveBuff += 9; //skip "Visited:"


					
							//Write URL
							printf("%s\n", moveBuff);
							WriteFile(dmp->dumpFile, moveBuff, strlen(moveBuff), (LPDWORD) &writtenBytes, NULL);
							WriteFile(dmp->dumpFile, "\r\n", strlen("\r\n"), (LPDWORD) &writtenBytes, NULL);

							//Next...
							moveBuff += strlen(moveBuff) -1;
						}
					}
				}
			}
		//}				
	} else {
		dmp->unlocated_size += memInfo->RegionSize;
	}

	return 0;
}

void DestroyIEFilter1(DUMP_SESSION* filter) {
	Destroy_MemoryDump(filter);
}

/*-----------------------------------------------------End Filter 1-----------------------------------------------------*/

/*--------------------------------------------------------Filter 2--------------------------------------------------------*/
DUMP_SESSION* InitiateIEFilter2(char* location, char* argument, int analyse_type) {
		return CreateUNICODEMemoryDump(location, "IE_URL_UNICODE_Search.txt", 0, 
		(argument==(char*) -1 ? DS_WRITE_LOCATION_STRING : strtol(argument, NULL, 10))
	);
}

/*Search for all URLs visited Internet explorer (UNICODE) .*/
int ApplyIEFilter2(DUMP_SESSION* dmp, HANDLE process, MEMORY_BASIC_INFORMATION* memInfo, char* buff, SIZE_T overflowSize) {
	/*'Signature'
	
		"Visited :" user@URL

	*/
	char signature[18]={0x56, 0x00, 0x69, 0x00, 0x73, 0x00, 0x69, 0x00, 0x74, 0x00, 0x65, 0x00, 0x64, 0x00, 0x3A, 0x00, 0x20, 0x00};
	char* moveBuff=buff;  //Cur pos
	wchar_t* moveBuff2; //Back-up cur pos
	int writtenBytes;	  //Returnvalue from Writefile()
	int readSize=0;		  //size of found URL

	if(memInfo->State!=MEM_FREE && memInfo->State!=MEM_RESERVE) {
		for(; moveBuff<(buff + memInfo->RegionSize); moveBuff++) {
			if(	memcmp(moveBuff, signature,   18) == 0) { //look for "Visited :"

				/*Search for @, the end of a username*/
				moveBuff2 = (wchar_t*) (moveBuff+18);
				while(*moveBuff2!='@' && moveBuff2!=(wchar_t*) (buff+overflowSize) && moveBuff2!=(wchar_t*) (buff+overflowSize+1)  && *moveBuff2!=0)
					moveBuff2++;

				if(*moveBuff2=='@' && moveBuff2!=(wchar_t*) (buff+overflowSize) && moveBuff2!=(wchar_t*) (buff+overflowSize+1)) {
					moveBuff2++;

					/*look if the protocolname meets it's requirments*/
					while(moveBuff2!=(wchar_t*) (buff+overflowSize) && moveBuff2!=(wchar_t*) (buff+overflowSize+1) 
					&& *moveBuff2!=0
					&& !(*moveBuff2==':')
					&& !(
					(*moveBuff2 < 'a' || *moveBuff2 > 'z') 
					&& (*moveBuff2 < '0' || *moveBuff2 > '9') 
					&& *moveBuff2 != '-'
					&& *moveBuff2 != '.')
					)
						moveBuff2++;

					/*If protocolname is found it is a URL, write it to file*/
					if(moveBuff2!=(wchar_t*) (buff+overflowSize) && moveBuff2!=(wchar_t*) (buff+overflowSize+1) 
						&& *moveBuff2!=0 &&
						(*moveBuff2==':')) {

						if(dmp->flags&DS_WRITE_LOCATION_STRING) {
							printf("Address: %p: ", (memlong) memInfo->BaseAddress + (moveBuff - buff));
							wsprintfW((LPWSTR) dmp->string_location, L"Address: %p, \0", (memlong) memInfo->BaseAddress + (moveBuff - buff));
							WriteFile(dmp->dumpFile, dmp->string_location, wcslen((wchar_t*) dmp->string_location)*2, (LPDWORD) &writtenBytes, NULL);
						}

						moveBuff += 18; //skip "Visited:"


					
						//Write URL
						wprintf(L"%s\n", moveBuff);
						WriteFile(dmp->dumpFile, moveBuff, wcslen((wchar_t*) moveBuff)*2, (LPDWORD) &writtenBytes, NULL);
						WriteFile(dmp->dumpFile, L"\r\n", wcslen(L"\r\n")*2, (LPDWORD) &writtenBytes, NULL);

						//Next...
						moveBuff += (wcslen((wchar_t*) moveBuff)*2) -1;
					}
				}
			}
		}			
	} else {
		dmp->unlocated_size += memInfo->RegionSize;
	}

	return 0;
}

void DestroyIEFilter2(DUMP_SESSION* filter) {
	Destroy_MemoryDump(filter);
}

/*-----------------------------------------------------End Filter 2-----------------------------------------------------*/

/*--------------------------------------------------------Filter 3--------------------------------------------------------*/
DUMP_SESSION* InitiateIEFilter3(char* location, char* argument, int analyse_type) {
	DUMP_SESSION* tmpDump;
	tmpDump = CreateMemoryDump(location, "IE Cookie Search.txt", 0, 
		(argument==(char*) -1 ? DS_WRITE_LOCATION_STRING : strtol(argument, NULL, 10))
	);

	/*
	When there is live memory search we can find the cookies 9only only the domains
	*/
	if(analyse_type==ANALYSE_MEMORY) {
		tmpDump->freePointer = createList();
		addToList(tmpDump->freePointer, createList());
		addToList(tmpDump->freePointer, createList());
	} else {
		tmpDump->freePointer = 0;
	}

	return tmpDump;
}

/*Look for cookies in IE step 1*/
int ApplyIEFilter3(DUMP_SESSION* dmp, HANDLE process, MEMORY_BASIC_INFORMATION* memInfo, char* buff, SIZE_T overflowSize) {
	char* moveBuff=buff;
	char* moveBuff2;
	char* moveBuff3;
	char* moveBuff4;
	int writtenBytes;
	int readSize=0;
	int i;
	int extraSize;

	char* copyBuff = 0;


	if(memInfo->State!=MEM_FREE && memInfo->State!=MEM_RESERVE) {
		if(dmp->freePointer!=0) {
			/*Backup the memory, this is later used to find the cookies (we only find domains and URLs for now).*/
			copyBuff = (char*) malloc(sizeof(MEMORY_BASIC_INFORMATION) + overflowSize + default_empty_overflow_size);
			memcpy(copyBuff, memInfo, sizeof(MEMORY_BASIC_INFORMATION));
			memcpy(copyBuff + sizeof(MEMORY_BASIC_INFORMATION), buff, overflowSize);
			addToList(getFromList(dmp->freePointer, 0), (void*) copyBuff);
		}

		extraSize = (overflowSize - memInfo->RegionSize);
		if(extraSize!=0)
			extraSize /= 2;

		for(; moveBuff<(buff + memInfo->RegionSize + extraSize); moveBuff++) {
			if(moveBuff>(buff + 1)
				&&strlen(moveBuff) > 3) {  //domainname is always >3 bytes
				moveBuff2 = moveBuff;

				/*look if the domainname meets it's requirments:
				- Letters a - z
				- numbers 0-9
				- '-' or '.' */
				while(moveBuff2!=buff+overflowSize
				&& *moveBuff2!=0
				&& !(
					(*moveBuff2 < 'a' || *moveBuff2 > 'z') 
					&& (*moveBuff2 < '0' || *moveBuff2 > '9') 
					&& *moveBuff2 != '-'
					&& *moveBuff2 != '.'
				))
					moveBuff2++;

				/*Size of the domainname*/
				readSize = moveBuff2 - moveBuff;


				moveBuff3 = moveBuff2;
				moveBuff3 += readSize + 1;

				/*Check if we reached the end of the buffer?*/
				if(moveBuff2!=buff+overflowSize
				&& *moveBuff2==0 
				&& *moveBuff3==0) {

					moveBuff3 = moveBuff2 + 1;
					moveBuff2--;

					/*Check if the next string is a copy of the domain in reverse direction*/
					for(i=0; i<readSize; i++) {
						if(*moveBuff3 != *moveBuff2)
							break;

						moveBuff3++;
						moveBuff2--;
					}

					moveBuff4 = moveBuff;
					moveBuff4-=2;

					/*look for the URL in front of the domainname*/
					while(moveBuff4!=buff
						&& *moveBuff4!=0)
						moveBuff4--;

					/*Check if we reached the end of the buffer and does the URL start with a slash?*/
					if(i==readSize
					&& *moveBuff3 == *moveBuff2
					&& (*moveBuff4==0 && *(moveBuff4+1)=='/'
					|| *moveBuff4=='/'
					&& moveBuff4<buff + memInfo->RegionSize)
					) {

						/*We found an URL, 
						- Write it to the file if we do a search on a memory dump
						- Set the domainname in the list for later research if this is live memory research*/
						moveBuff2 = moveBuff + readSize+1;

						if(*moveBuff4==0)
							*moveBuff4++;

						if(dmp->freePointer!=0) {
							addToList(getFromList(dmp->freePointer, 1), (void*) ((memlong) memInfo->BaseAddress + (moveBuff4 - buff)));
						} else {
							if(dmp->flags&DS_WRITE_LOCATION_STRING) {
								printf("Address: %p: ", (memlong) memInfo->BaseAddress + (moveBuff - buff));
								sprintf(dmp->string_location, "Address: %p: ", (memlong) memInfo->BaseAddress + (moveBuff - buff));
								WriteFile(dmp->dumpFile, dmp->string_location, strlen(dmp->string_location), (LPDWORD) &writtenBytes, NULL);
							}


							//Write URL
							printf("%s%s\n", moveBuff2, moveBuff4);
							WriteFile(dmp->dumpFile, moveBuff2, readSize, (LPDWORD) &writtenBytes, NULL);
							WriteFile(dmp->dumpFile, moveBuff4, strlen(moveBuff4), (LPDWORD) &writtenBytes, NULL);
							WriteFile(dmp->dumpFile, "\r\n", strlen("\r\n"), (LPDWORD) &writtenBytes, NULL);
						}

						//Next...
						moveBuff += ((readSize+1)*2) -1;
					} else {
						if(strlen(moveBuff))
							moveBuff += strlen(moveBuff) -1;
					}

				} else {
					if(strlen(moveBuff))
						moveBuff += strlen(moveBuff) -1;
				}
			} else {
				if(strlen(moveBuff))
					moveBuff += strlen(moveBuff) -1;
			}
		}	
	} else {
		dmp->unlocated_size += memInfo->RegionSize;
	}

	return 0;
}

void DestroyIEFilter3(DUMP_SESSION* filter) {
	int i;
	//If we are research on live memory, we can go and find the cookies now
	if(filter->freePointer!=0) {
		//Loop through the list that is made before
		for(i=0; i<countList(getFromList(filter->freePointer, 1)); i++) {
			char* foundOffset;
			char* pLocatie;	
			char* pDomein;
			char* pHeaderCookie;
			char* vHeaderCookie;
			char* pcookieNaam;
			char* pcookieWaarde;
			int writtenBytes;
			MEMORY_BASIC_INFORMATION* retMemInfo;	

			//Convert Virtual Address from where we found the domainname in the remote process to a valid memory location in this process
			pLocatie = (char*) ProcessVirtualPointerToVP(getFromList(filter->freePointer, 0), getFromList(getFromList(filter->freePointer, 1), i));

			//Get pos of domain
			pDomein = pLocatie;
			pDomein += strlen(pDomein) + 1; //skip URL
			pDomein += strlen(pDomein) + 1; //skip reversed domainname

			/*Write location from found domainname*/
			if(filter->flags&DS_WRITE_LOCATION_STRING) {
				printf("Address: %p: ", getFromList(getFromList(filter->freePointer, 1), i));
				sprintf(filter->string_location, "Address: %p: \r\n", getFromList(getFromList(filter->freePointer, 1), i));
				WriteFile(filter->dumpFile, filter->string_location, strlen(filter->string_location), (LPDWORD) &writtenBytes, NULL);
			}


			//write domain to file
			printf("%s%s\n", pDomein, pLocatie);
			WriteFile(filter->dumpFile, pDomein, strlen(pDomein), (LPDWORD) &writtenBytes, NULL);
			WriteFile(filter->dumpFile, pLocatie, strlen(pLocatie), (LPDWORD) &writtenBytes, NULL);
			WriteFile(filter->dumpFile, "\r\n", strlen("\r\n"), (LPDWORD) &writtenBytes, NULL);
			WriteFile(filter->dumpFile, "------------", strlen("------------"), (LPDWORD) &writtenBytes, NULL);

			/*Below here we are going to try and find the offset of the domain in the memory backuped earlier to try to find cookies*/
			retMemInfo = 0;
			foundOffset = 0;
			pcookieNaam = 0;
			pHeaderCookie = 0;
			do { 
				foundOffset = (char*) findPointerInMemory(getFromList(filter->freePointer, 0), //list with memory
					getFromList(getFromList(filter->freePointer, 1), i), //list with found domains
					&retMemInfo, //output with found memory info
					retMemInfo, //the last output, this will let the function skip the already searched memory
					foundOffset, //last found memoryaddress
					MODE_32_BIT //Flags: MODE_32_BIT we are looking for 32-bit address, only effective when on a 64-bit application.
				);

				/*Look if the found address is part of a top-cookie header?.*/
			} while(foundOffset!=0 && !((foundOffset - (char*)retMemInfo) >= 24 && *(int*)(foundOffset-20)==0 && *(int*)(foundOffset-24)==0));


			//Header is found, lets get the cookies
			if(foundOffset!=0) {
				/*Get address to cookie header*/
				pHeaderCookie = (char*) ProcessVirtualPointerToVP(getFromList(filter->freePointer, 0), (void*) *(int*)(foundOffset-16)); //Header first cookie
				vHeaderCookie =  (char*) *(int*)(foundOffset-16); //Virtual pointer to next cookie
				do { //Loop though all cookie headers
					if(pHeaderCookie) {
						//Get name
						pcookieNaam = (char*) ProcessVirtualPointerToVP(getFromList(filter->freePointer, 0), (void*) *(int*)(pHeaderCookie+24));
						pcookieWaarde = (char*) ProcessVirtualPointerToVP(getFromList(filter->freePointer, 0), (void*) *(int*)(pHeaderCookie+28));

						/*write name*/
						WriteFile(filter->dumpFile, "\r\n", strlen("\r\n"), (LPDWORD) &writtenBytes, NULL);

						if(filter->flags&DS_WRITE_LOCATION_STRING) {
							printf("Address: %p: ", vHeaderCookie);
							sprintf(filter->string_location, "Address: %p: \r\n", vHeaderCookie);
							WriteFile(filter->dumpFile, filter->string_location, strlen(filter->string_location), (LPDWORD) &writtenBytes, NULL);
						}

						printf("%s=%s\n", pcookieNaam, pcookieWaarde);
						WriteFile(filter->dumpFile, "name: ", strlen("name: "), (LPDWORD) &writtenBytes, NULL);
						if(pcookieNaam==0)
							WriteFile(filter->dumpFile, "Unknown", strlen("Unknown"), (LPDWORD) &writtenBytes, NULL);
						else
							WriteFile(filter->dumpFile, pcookieNaam, strlen(pcookieNaam), (LPDWORD) &writtenBytes, NULL);
						WriteFile(filter->dumpFile, "\r\nValue: ", strlen("\r\nValue: "), (LPDWORD) &writtenBytes, NULL);
						if(pcookieWaarde==0)
							WriteFile(filter->dumpFile, "Unknown", strlen("Unknown"), (LPDWORD) &writtenBytes, NULL);
						else
							WriteFile(filter->dumpFile, pcookieWaarde, strlen(pcookieWaarde), (LPDWORD) &writtenBytes, NULL);
						WriteFile(filter->dumpFile, "\r\n", strlen("\r\n"), (LPDWORD) &writtenBytes, NULL);

						/*Get next cookie from the list*/
						vHeaderCookie =  (char*) *(int*)(pHeaderCookie+20);
						pHeaderCookie  = (char*) ProcessVirtualPointerToVP(getFromList(filter->freePointer, 0), (void*) *(int*)(pHeaderCookie+20));
					}

				} while(pHeaderCookie!=0);
				WriteFile(filter->dumpFile, "\r\n", strlen("\r\n"), (LPDWORD) &writtenBytes, NULL);
				WriteFile(filter->dumpFile, "\r\n", strlen("\r\n"), (LPDWORD) &writtenBytes, NULL);
			}
		}

		/*Free all the memory*/
		for(i = 0; i<countList(getFromList(filter->freePointer, 0)); i++) {
			free(getFromList(getFromList(filter->freePointer, 0), i));
		}

		freeList(getFromList(filter->freePointer, 0));
		freeList(getFromList(filter->freePointer, 1));

		freeList(filter->freePointer);
	}

	Destroy_MemoryDump(filter);
}

/*Convert virtual process memory location to memory location in this process*/
void* ProcessVirtualPointerToVP(void* list, void* PVP) {
	int i=0;
	MEMORY_BASIC_INFORMATION* memInfo;

	if(PVP==0)
		return 0;

	for(i = 0; i<countList(list); i++) {
		memInfo = (MEMORY_BASIC_INFORMATION*) getFromList(list, i);
		if(memInfo->BaseAddress<=PVP
		&& (char*)memInfo->BaseAddress + memInfo->RegionSize > PVP)
			return (char*)memInfo + sizeof(MEMORY_BASIC_INFORMATION) + ((char*) PVP - memInfo->BaseAddress);
	}
	return 0;
}

/*Look if a pointer to a certain location is somewhere stored in the memory*/
void* findPointerInMemory(void* list, void* PVP, MEMORY_BASIC_INFORMATION** retMemInfo, MEMORY_BASIC_INFORMATION* memOffset, void* offset, int flags) {
	int i=0;
	int pointer = 0;
	MEMORY_BASIC_INFORMATION* memInfo;
	char* searchBase;

	if(flags&MODE_32_BIT)
		pointer = (int) PVP;

	for(i = 0; i<countList(list); i++) {
		memInfo = (MEMORY_BASIC_INFORMATION*) getFromList(list, i);
		if(memOffset==0 ||
		memOffset==memInfo) {
			memOffset = 0;
			*retMemInfo = memInfo;
			searchBase = ((char*) memInfo) + sizeof(MEMORY_BASIC_INFORMATION);

			if(offset) {
				searchBase = offset;
				searchBase++;
				offset = 0;
			}

			for(; searchBase<((char*) memInfo + sizeof(MEMORY_BASIC_INFORMATION) + memInfo->RegionSize); searchBase++) {
				if(flags&MODE_32_BIT) {
					if(*(int*)searchBase == (int) PVP) {
						return searchBase;
					}
				
				} else {
					if(*(void**)searchBase == PVP) {
						return searchBase;
					}
				}
			}
		}
	}
	return 0;
}

/*-----------------------------------------------------End Filter 3-----------------------------------------------------*/